
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Tomcat源码分析——server.xml文件的加载 / iVAN</title>

    <meta name="description" content="Tomcat源码分析——server.xml文件的加载 前言 作为Java程序员,对于tomcat的server.xml想必都不陌生.本文基于Tomcat7.0的Java源码,对server.xml文件是如何加载的进行分析. 源码分析 Bootstrap的load方法用于加载tomcat的server.xml,实际是通过反射调用Catalina的load方法,代码如下: /** * Load daemon. */ private void load(String[] arguments) throws Exception { // Call the">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Tomcat源码分析——server.xml文件的加载</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>前言</h1>
<p>作为Java程序员，对于tomcat的server.xml想必都不陌生。本文基于Tomcat7.0的Java源码，对server.xml文件是如何加载的进行分析。</p>
<h1>源码分析</h1>
<p>Bootstrap的load方法用于加载tomcat的server.xml，实际是通过反射调用Catalina的load方法，代码如下：</p>
<pre><code>/**
 * Load daemon.
 */
private void load(String[] arguments)
    throws Exception {

    // Call the load() method
    String methodName = "load";
    Object param[];
    Class&lt;?&gt; paramTypes[];
    if (arguments==null || arguments.length==0) {
        paramTypes = null;
        param = null;
    } else {
        paramTypes = new Class[1];
        paramTypes[0] = arguments.getClass();
        param = new Object[1];
        param[0] = arguments;
    }
    Method method =
        catalinaDaemon.getClass().getMethod(methodName, paramTypes);
    if (log.isDebugEnabled())
        log.debug("Calling startup class " + method);
    method.invoke(catalinaDaemon, param);

}
</code></pre>
<p>Catalina的load方法实现如下：</p>
<pre><code>/**
 * Start a new server instance.
 */
public void load() {

    long t1 = System.nanoTime();

    initDirs();

    // Before digester - it may be needed

    initNaming();

    // Create and execute our Digester
    Digester digester = createStartDigester();

    InputSource inputSource = null;
    InputStream inputStream = null;
    File file = null;
    try {
        file = configFile();
        inputStream = new FileInputStream(file);
        inputSource = new InputSource("file://" + file.getAbsolutePath());
    } catch (Exception e) {
        // Ignore
    }
    if (inputStream == null) {
        try {
            inputStream = getClass().getClassLoader()
                .getResourceAsStream(getConfigFile());
            inputSource = new InputSource
                (getClass().getClassLoader()
                 .getResource(getConfigFile()).toString());
        } catch (Exception e) {
            // Ignore
        }
    }

    // This should be included in catalina.jar
    // Alternative: don't bother with xml, just create it manually.
    if( inputStream==null ) {
        try {
            inputStream = getClass().getClassLoader()
            .getResourceAsStream("server-embed.xml");
            inputSource = new InputSource
            (getClass().getClassLoader()
                    .getResource("server-embed.xml").toString());
        } catch (Exception e) {
            // Ignore
        }
    }

    if ((inputStream == null) &amp;&amp; (file != null)) {
        log.warn("Can't load server.xml from " + file.getAbsolutePath());
        if (file.exists() &amp;&amp; !file.canRead()) {
            log.warn("Permissions incorrect, read permission is not allowed on the file.");
        }
        return;
    }

    try {
        inputSource.setByteStream(inputStream);
        digester.push(this);
        digester.parse(inputSource);
        inputStream.close();
    } catch (Exception e) {
        log.warn("Catalina.start using "
                           + getConfigFile() + ": " , e);
        return;
    }

    // Stream redirection
    initStreams();

    // Start the new server
    try {
        getServer().init();
    } catch (LifecycleException e) {
        if (Boolean.getBoolean("org.apache.catalina.startup.EXIT_ON_INIT_FAILURE"))
            throw new java.lang.Error(e);
        else
            log.error("Catalina.start", e);

    }

    long t2 = System.nanoTime();
    if(log.isInfoEnabled())
        log.info("Initialization processed in " + ((t2 - t1) / 1000000) + " ms");

}
</code></pre>
<p>这里对上述代码进行分析：<br />
1) initDirs方法用于对catalina.home和catalina.base的一些检查工作。<br />
2) initNaming方法给系统设置java.naming.factory.url.pkgs和java.naming.factory.initial。在创建JNDI上下文时，使用Context.INITIAL_CONTEXT_FACTORY（"java.naming.factory.initial"）属性，来指定创建JNDI上下文的工厂类；Context.URL_PKG_PREFIXES("java.naming.factory.url.pkgs")用在查询url中包括scheme方法id时创建对应的JNDI上下文，例如查询"java:/jdbc/test1"等类似查询上，即以冒号":"标识的shceme。Context.URL_PKG_PREFIXES属性值有多个java 包(package)路径，其中以冒号":"分隔各个包路径，这些包路径中包括JNDI相关实现类。当在JNDI上下文中查找"java:"这类包括scheme方案ID的url时，InitialContext类将优先查找Context.URL_PKG_PREFIXES属性指定的包路径中是否存在 scheme+"."+scheme + "URLContextFactory"工厂类（需要实现ObjectFactory接口），如果存在此工厂类，则调用此工厂类的getObjectInstance方法获得此scheme方案ID对应的jndi上下文，再在此上下文中继续查找对应的url。<br />
3) createStartDigester方法创建并配置将要用来启动的Digester实例，并且设置一些列Rule，具体映射到server.xml。<br />
4) 使用FileInputStream获取conf/server.xml配置文件输入流。<br />
5) 将FileInputStream封装为InputSource，并且调用Digester的parse方法进行解析。<br />
6) initStreams对输出流、错误流重定向。<br />
7) 初始化server，具体实现本文不做分析。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-22 14:10:36</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/server/" title="server">server</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/tomcat/" title="tomcat">tomcat</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Tomcat源码分析——server.xml文件的加载的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKmY2z.html" rel="bookmark">Tomcat源码分析&mdash;&mdash;server&period;xml文件的解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 在&lt;Tomcat源码分析--server.xml文件的加载&gt;一文中我们介绍了server.xml的加载,本文基于Tomcat7.0的Java源码,接着对server.xml文件是如何解析的进行分析. 概要 规则 Tomcat将server.xml文件中的所有元素上的属性都抽象为Rule,以Server元素为例,在内存中对应Server实例,Server实例的属性值就来自于Server元素的属性值.通过对规则(Rule)的应用,最终改变Server实例的属性值. Rule是一个抽象类,其中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQd4kp.html" rel="bookmark">TOMCAT源码分析&mdash;&mdash;启动服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 熟悉Tomcat的工程师们,肯定都知道Tomcat是如何启动与停止的.对于startup.sh.startup.bat.shutdown.sh.shutdown.bat等脚本或者批处理命令,大家一定知道改如何使用它,但是它们究竟是如何实现的,尤其是shutdown.sh脚本(或者shutdown.bat)究竟是如何和Tomcat进程通信的呢?本文将通过对Tomcat7.0的源码阅读,深入剖析这一过程. 由于在生产环境中,Tomcat一般部署在Linux系统下,所以本文将以startup.s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdRWX6b.html" rel="bookmark">TOMCAT源码分析&mdash;&mdash;生命周期管理（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 从server.xml文件解析出来的各个对象都是容器,比如:Server.Service.Connector等.这些容器都具有新建.初始化完成.启动.停止.失败.销毁等状态.tomcat的实现提供了对这些容器的生命周期管理,本文将通过对Tomcat7.0的源码阅读,深入剖析这一过程. TOMCAT生命周期类接口设计 我们先阅读图1,从中了解Tomcat涉及生命周期管理的主要类. 图1 Tomcat生命周期类接口设计 这里对图1中涉及的主要类作个简单介绍: Lifecycle:定义了容器生命			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pker4yb.html" rel="bookmark">TOMCAT源码分析&mdash;&mdash;停止服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 在&lt;TOMCAT源码分析--启动服务&gt;一文中我介绍了Tomcat服务的启动过程分析,本文讲解Tomcat服务是如何停止的. 停止过程分析 我们停止Tomcat的命令如下: sh shutdown.sh 所以,将从shell脚本shutdown.sh开始分析Tomcat的停止过程.shutdown.sh的脚本代码见代码清单10. 代码清单10 os400=false case &quot;`uname`&quot; in OS400*) os400=true;; esac # resolv			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M94Emob.html" rel="bookmark">TOMCAT源码分析&mdash;&mdash;生命周期管理（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 我在&lt;TOMCAT源码分析--生命周期管理(一)&gt;一文中介绍了TOMCAT生命周期类接口设计.JMX.容器以及基于容器的事件与监听等内容,本文将接着介绍Tomcat7.0中容器生命周期的管理. 容器生命周期 每个容器都会有自身的生命周期,其中也涉及状态的迁移,以及伴随的事件生成,本节详细介绍Tomcat中的容器生命周期实现.所有容器的转态转换(如新疆.初始化.启动.停止等)都是由外到内,由上到下进行,即先执行父容器的状态转换及相关操作,然后再执行子容器的转态转换,这个过程是层层迭代执行的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MA7OYvz.html" rel="bookmark">spring mvc-Spring mvc&plus;mybatis&plus;maven的项目tomcat启动的时候，控制台不输出xml文件的加载信息</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Spring mvc+mybatis+maven的项目tomcat启动的时候,控制台不输出xml文件的加载信息 2014-3-17 9:52:18 org.apache.catalina.core.AprLifecycleListener init信息: Loaded APR based Apache Tomcat Native library 1.1.24 using APR version 1.4.6.2014-3-17 9:52:18 org.apache.catalina.co			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MywYaZz.html" rel="bookmark">Tomcat源码分析----Container初始化与加载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在本章节中,以下几个问题会被回答: - web容器和servlet容器的区别是什么: - 在springMVC中的web.xml是什么时候加载到tomcat中的: - tomcat是怎么加载我们的web服务的: - tomcat是怎么实现的热部署: 1 Container基本结构 从上文中有讲到,Connector和Container的初始化工作是由Digester来解析conf/server.xml来完成的.而在server.xml中已经告诉我们了Container的基本结构.那么我们先来看看			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQm4Op.html" rel="bookmark">Tomcat源码分析----初始化与启动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.前言 1.1 问题思考 在阅读tomcat源码前,我们一般都会有如下几个疑问: web容器和servlet容器的区别是什么: 在springMVC中的web.xml是什么时候加载到tomcat中的: tomcat是怎么加载我们的web服务的: tomcat是怎么实现的热部署: 一个http请求是怎么被tomcat监听到的,会有哪些处理: 为什么请求可以有需要通过nginx的,也可以不需要nginx的直接请求到tomcat上? -- 如果你想知道答案,那么接下来的文章会告诉你. 1.2 基本姿			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Myng6Jp.html" rel="bookmark">tomcat源码分析-Bootstrap操作Catalina</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.前言 1.1 问题思考 在阅读tomcat源码前,我们一般都会有如下几个疑问: web容器和servlet容器的区别是什么: 在springMVC中的web.xml是什么时候加载到tomcat中的: tomcat是怎么加载我们的web服务的: tomcat是怎么实现的热部署: 一个http请求是怎么被tomcat监听到的,会有哪些处理: 为什么请求可以有需要通过nginx的,也可以不需要nginx的直接请求到tomcat上? -- 如果你想知道答案,那么接下来的文章会告诉你. 1.2 基本姿			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYjqZp.html" rel="bookmark" class="title">用360浏览器伪装iPhone触屏版空间</a>
					<div>
						  操作前请注意:本教程经测试仅对于使用chrome内核的360浏览器6.1正式版或更高版本.360浏览器极速版.谷歌浏览器等等有效,其他的双核浏览器可能不适用哟. 正式开始操作: 1)在360浏览器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnPrWb.html" rel="bookmark" class="title">WEB服务器家族的瑞士军刀</a>
					<div>
						web|web服务|web服务器 4D WebSTAR V是一款MAC平台的多功能服务器软件包,它包含了WEB,FTP,WebdAV和邮件服务器,目标客户定位在中小型企业. 设想一下如果你运行着的是美 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2eVqz.html" rel="bookmark" class="title">技巧：自制Flash播放器</a>
					<div>
						flash播放|技巧 网上精彩的Flash动画随处可见,大家多是用IE浏览器或Flash Player在观看,有没有想过自己动手,做一款个人专用的Flash播放器?要完成这个愿望,你无需懂得编程知识, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjXn5p.html" rel="bookmark" class="title">网站模板优化是必经之路</a>
					<div>
						有些SEOer在代码方面不太熟悉,很容易忽略了对网站模板的优化.还有的SEOer打着&quot;内容为王,外链为皇&quot;旗号,把网站模板置之不顾.这是一个危险的想法,甚至有的SEOer伙伴连自己 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJWv7b.html" rel="bookmark" class="title">8&period;14更新百度K站的个人分析</a>
					<div>
						今天一大早,还是习惯性的打开站长工具来查一下自己网站的收录,排名,快照情况.发现自己的一个淘宝客的网站被K了,虽然早些时候被度娘K的只剩首页.但这么长时间我已经加了文章内容呀,也不见作弊呀.按照常理不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyL9qb.html" rel="bookmark" class="title">suse rpm安装mysql的过程</a>
					<div>
						suse mysql 5.0.18-16.i586 rpm 安装过程 主要是解决依赖的一些问题,以前是把包下载的到硬盘上的,只需要mount就可以了然后查找 mysql 1) find / -name ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7k1oAz.html" rel="bookmark" class="title">Vmware虚拟机下如何迁移Oracle RAC</a>
					<div>
						最近虚拟机下的Oracle 10g RAC搬家,搬家完毕之后,Oracle 集群resource之VIP无法正常启动,收到了CRS-0233: Resource or relatives are cu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyvABb.html" rel="bookmark" class="title">win8蓝牙图标怎么办怎么办？</a>
					<div>
						  方法一.首先第一个原因很有可能是没有安装蓝牙驱动,鼠标点击我的电脑,进入设备管理器中,查看蓝牙状态,看设备管理器中是否可以看到蓝牙设备.如果有黄色叹号就是驱动问题了. 方法二.Windows 8系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRw72ap.html" rel="bookmark" class="title">Word文档如何在小方块里打钩？</a>
					<div>
						  1.在你的电脑上打开一个Word文档,新建一个空白页,如图所示. 2.输入跟方框选择有关的内容,比如,我们输入服务满意度调查,分成几个档,每一档前面都有一个小方框,如图所示. 3.输入好以后,我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoW3Rb.html" rel="bookmark" class="title">io-java 把文件夹里 类似文件名打包</a>
					<div>
						问题描述 java 把文件夹里 类似文件名打包 大神们好: 现在有一个目录 里面有许多文件 格式类似 12345678-201601.001.txt ,12345678-201601.002.txt  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7m7RM.html" rel="bookmark" class="title">我想设计一个数据库，用来存课表，可是查询的时候该怎么写</a>
					<div>
						问题描述 我想设计一个数据库,用来存课表,可是查询的时候该怎么写 解决方案 首先你得 创建表以及各个列值. 推荐: 列值:key1(储存第几周).key2(星期几).key3(时间段,比如早上8点到1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnK98oz.html" rel="bookmark" class="title">win7 tomcat启动报错</a>
					<div>
						问题描述 2011-6-1511:02:03org.apache.catalina.core.AprLifecycleListenerinit信息:TheAPRbasedApacheTomcatNat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RDPAz.html" rel="bookmark" class="title">java 调用C语言，然后在 c中创建jvm（想在C中再调用Java）返回-1&excl;</a>
					<div>
						问题描述 java 调用C语言,然后在 c中创建jvm(想在C中再调用Java)返回-1! ,请教一个问题: 现在Java 调C 代码( C作为 .so 文件), 和C(C作为可执行程序)调用Java ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Ame3z.html" rel="bookmark" class="title">分享：如何站内优化的细节设置来留住用户</a>
					<div>
						网站优化不一定增加外链就对排名有帮助的,要懂得内外结合,相辅相成才能完全得到http://www.aliyun.com/zixun/aggregation/37805.html&quot;&gt;搜索 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjABdM.html" rel="bookmark" class="title">&lbrack;转载&rsqb;修复IE8进程延迟关闭的问题 充分释放资源</a>
					<div>
						      众所周知,微软 Internet Explorer 8 浏览器刚打开的时候会在&quot;Windows任务管理器&quot;形成两个名称同为 iexplorer.exe 的进程,其中,一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgeaob.html" rel="bookmark" class="title">openxml-在用OpenXML替换word书签，请问怎么从bookmarkEnd获得bookmarkStart？</a>
					<div>
						问题描述 在用OpenXML替换word书签,请问怎么从bookmarkEnd获得bookmarkStart? 如题,做的时候参考了:http://stackoverflow.com/question ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK3oDb.html" rel="bookmark" class="title">抢先体验QQ空间6&period;0</a>
					<div>
						话说笔者非常幸运的获得了QQ空间6.0的内测资格,觊觎6.0内测资格的童鞋们,不用再打探谁谁的空间是6.0版本了,现在就跟笔者一起来体验一番吧! 登录QQ空间后首先弹出升级到6.0的提示,&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkA2J7b.html" rel="bookmark" class="title">Android开发之ListView页眉页脚效果VS android背景渐变</a>
					<div>
						大家都知道,在我们调用ListView的addFooterView()方法给List增加一个页脚时,如果列表内容很多,超过了屏幕大小,那么页脚就看不到了,可我们一般想要的效果是如下图所示的,在List ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodK93M.html" rel="bookmark" class="title">linux版mantis 安装和测试笔记</a>
					<div>
						1.先要安装好 LNMP/LAMP 的环境,前面有详细介绍,不再赘述. 2.到 mantis 官网上下载最新最稳定的源码 点击打开链接 mantis官网 3.解压都 website 的主目录,更改其可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAVZwb.html" rel="bookmark" class="title">qtcreator-Qtestlib的鼠标单击方法不起作用</a>
					<div>
						问题描述 Qtestlib的鼠标单击方法不起作用 Ui::MainWindow ui; QMainWindow *window1=new QMainWindow; ui.setupUi(window1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAx1jb.html" rel="bookmark" class="title">mfc 对话框-MFC编程中怎么可以使对话框慢慢弹出并有背景图片？</a>
					<div>
						问题描述 MFC编程中怎么可以使对话框慢慢弹出并有背景图片? 自己写了代码,之前有背景图片,但是加了对话框弹出效果后图片出不来了app最小化后对话框才有显示这个该怎么办? 解决方案 Vc++程序调试, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Rvknz.html" rel="bookmark" class="title">strongloop查询-strongloop如何进行复杂的查询</a>
					<div>
						问题描述 strongloop如何进行复杂的查询 因为strongloop是对象式编程,查询如果多表联查再加条件的话本人表达不出来,strongloop的查询不像sql那样方便,多表查询用sql是可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22qqrb.html" rel="bookmark" class="title">网购鞭炮 缩水近半</a>
					<div>
						本报讯(记者 韩爱青 实习生 夏秋楠)买菜缺斤少两,谁想到买鞭炮还&quot;缺响&quot;呢?昨日,市民张小姐向本报新闻热线反映,她在网上团购了一套http://www.aliyun.com/zi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAk2XQz.html" rel="bookmark" class="title">网络游戏虚拟货币广泛应用于网络游戏经营服务中</a>
					<div>
						长江商报消息 据新华社电 网络游戏虚拟货币广泛应用于网络游戏经营服务中.然而浙江温州的一家棋牌http://www.aliyun.com/zixun/aggregation/28589.html&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QZAqM.html" rel="bookmark" class="title">零基础学JavaScript最新动画教程&plus;iso光盘下载&lowbar;基础知识</a>
					<div>
						最新动画教程+光盘--零基础学JavaScript 从网上找到的好资源,机械工业出版社的最新编程入门书的光盘和动画教程. 电驴下载地址:http://board.verycd.com/t488833. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWgekz.html" rel="bookmark" class="title">在&period;jsp中非表单请求action的几种方式总结&lowbar;JSP编程</a>
					<div>
						一: 复制代码 代码如下: &lt;a href=&quot;userAction.do?flag=user_regist&quot;&gt;注册&lt;/a&gt; 二: 复制代码 代码如下: &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0y3Op.html" rel="bookmark" class="title">JavaScript实现简单图片滚动附源码下载&lowbar;javascript技巧</a>
					<div>
						昨晚德国和葡萄牙的焦点之战你看了吗?北京时间凌晨的比赛中,C罗领衔的葡萄牙0-4德国被完灭--他是金球奖得主.欧洲金靴.欧冠冠军核心,在葡萄牙队--9张图 C罗告诉你什么叫欲哭无泪 复制代码 代码如下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkOVKM.html" rel="bookmark" class="title">以前搜集的一些资料---如何使用asp在自己的网站建立投票机制&lpar;1&rpar;</a>
					<div>
						一个很不错的建立自己的投票系统的ASP程序大家仔细读读,只要能够理解中间的关键技术就能够在自己的网站上建立自己的投票站了.文件整理得很仓促,希望大家谅解.版权所有:ASP Pollsversion 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Neorp.html" rel="bookmark" class="title">net 地图控件 &num;-GMAP&period;NET 相关事件问题？</a>
					<div>
						问题描述 GMAP.NET 相关事件问题? 正在了解GMAP.NET 控件,试了一下,该控件的Marker相关事件可以响应.但是多边形和路径的相关事件没有触发,不知怎么回事,望各位指教!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boq2g3p.html" rel="bookmark" class="title">中国联通首批iPhone 4用户合约即将到期之际</a>
					<div>
						联通客服人员证实,这些用户可更换成iPhone 4S合约计划,也可更换成其它手机套餐,同时,&quot;机卡合一&quot;制度也不再执行.中国联通于2010年9月开始引进iPhone 4,并有零元购 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
